/*
Copyright (c) 2018-2019 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import React from 'react';
import { StyledCell } from './styled-components.js';
// When used with Grid, Cell does not actually return anything.
// All of the props are forwarded to a StyledCell inside of Grid.
export default function Cell(_ref) {
  var align = _ref.align,
      children = _ref.children,
      order = _ref.order,
      skip = _ref.skip,
      span = _ref.span;
  return React.createElement(StyledCell, {
    $align: align,
    $order: order,
    $skip: skip,
    $span: span
  }, children);
}