"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _darkThemePrimitives = require("./dark-theme-primitives.js");

/*
Copyright (c) 2018-2019 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
var WHITE = '#FFFFFF';
var BLACK = '#000000';
var _default = {
  colors: {
    // Semantic Colors
    // Font Color
    colorPrimary: _darkThemePrimitives.primitives.mono100,
    colorSecondary: _darkThemePrimitives.primitives.mono200,
    // Background
    background: _darkThemePrimitives.primitives.mono1000,
    backgroundAlt: _darkThemePrimitives.primitives.mono700,
    backgroundInv: _darkThemePrimitives.primitives.mono100,
    // Foreground
    foreground: _darkThemePrimitives.primitives.mono100,
    foregroundAlt: _darkThemePrimitives.primitives.mono300,
    foregroundInv: _darkThemePrimitives.primitives.mono1000,
    // Borders
    border: _darkThemePrimitives.primitives.mono600,
    borderAlt: _darkThemePrimitives.primitives.mono700,
    borderFocus: _darkThemePrimitives.primitives.primary,
    borderError: _darkThemePrimitives.primitives.negative,
    // Buttons
    buttonPrimaryFill: _darkThemePrimitives.primitives.primary,
    buttonPrimaryText: BLACK,
    buttonPrimaryHover: _darkThemePrimitives.primitives.primary100,
    buttonPrimaryActive: _darkThemePrimitives.primitives.primary200,
    buttonPrimarySelectedText: BLACK,
    buttonPrimarySelectedFill: _darkThemePrimitives.primitives.primary200,
    buttonPrimarySpinnerForeground: _darkThemePrimitives.primitives.primary700,
    buttonPrimarySpinnerBackground: _darkThemePrimitives.primitives.primary300,
    buttonSecondaryFill: _darkThemePrimitives.primitives.primary700,
    buttonSecondaryText: _darkThemePrimitives.primitives.primary,
    buttonSecondaryHover: _darkThemePrimitives.primitives.primary600,
    buttonSecondaryActive: _darkThemePrimitives.primitives.primary500,
    buttonSecondarySelectedText: _darkThemePrimitives.primitives.primary,
    buttonSecondarySelectedFill: _darkThemePrimitives.primitives.primary500,
    buttonSecondarySpinnerForeground: WHITE,
    buttonSecondarySpinnerBackground: _darkThemePrimitives.primitives.primary400,
    buttonTertiaryFill: 'transparent',
    buttonTertiaryText: _darkThemePrimitives.primitives.primary,
    buttonTertiaryHover: _darkThemePrimitives.primitives.primary700,
    buttonTertiaryActive: _darkThemePrimitives.primitives.primary600,
    buttonTertiarySelectedText: _darkThemePrimitives.primitives.primary,
    buttonTertiarySelectedFill: _darkThemePrimitives.primitives.primary600,
    buttonTertiarySpinnerForeground: _darkThemePrimitives.primitives.primary50,
    buttonTertiarySpinnerBackground: _darkThemePrimitives.primitives.primary500,
    buttonMinimalFill: 'transparent',
    buttonMinimalText: _darkThemePrimitives.primitives.primary,
    buttonMinimalHover: _darkThemePrimitives.primitives.primary700,
    buttonMinimalActive: _darkThemePrimitives.primitives.primary600,
    buttonMinimalSelectedText: _darkThemePrimitives.primitives.primary,
    buttonMinimalSelectedFill: _darkThemePrimitives.primitives.primary600,
    buttonMinimalSpinnerForeground: _darkThemePrimitives.primitives.primary50,
    buttonMinimalSpinnerBackground: _darkThemePrimitives.primitives.primary500,
    buttonDisabledFill: _darkThemePrimitives.primitives.mono600,
    buttonDisabledText: _darkThemePrimitives.primitives.mono300,
    buttonDisabledSpinnerForeground: _darkThemePrimitives.primitives.mono200,
    buttonDisabledSpinnerBackground: _darkThemePrimitives.primitives.mono400,
    // Breadcrumbs
    breadcrumbsText: _darkThemePrimitives.primitives.mono100,
    breadcrumbsSeparatorFill: _darkThemePrimitives.primitives.mono200,
    // Datepicker
    datepickerBackground: _darkThemePrimitives.primitives.mono600,
    datepickerDayFont: WHITE,
    datepickerDayFontDisabled: _darkThemePrimitives.primitives.mono100,
    datepickerDayPseudoSelected: _darkThemePrimitives.primitives.mono500,
    datepickerDayPseudoHighlighted: _darkThemePrimitives.primitives.mono600,
    // Calendar
    calendarBackground: _darkThemePrimitives.primitives.mono800,
    calendarForeground: WHITE,
    calendarForegroundDisabled: _darkThemePrimitives.primitives.mono300,
    calendarHeaderBackground: _darkThemePrimitives.primitives.primary700,
    calendarHeaderForeground: _darkThemePrimitives.primitives.primary,
    calendarHeaderBackgroundActive: _darkThemePrimitives.primitives.primary600,
    calendarHeaderForegroundDisabled: _darkThemePrimitives.primitives.primary500,
    calendarDayBackgroundPseudoSelected: _darkThemePrimitives.primitives.primary700,
    calendarDayForegroundPseudoSelected: _darkThemePrimitives.primitives.primary,
    calendarDayBackgroundPseudoSelectedHighlighted: _darkThemePrimitives.primitives.primary600,
    calendarDayForegroundPseudoSelectedHighlighted: _darkThemePrimitives.primitives.primary,
    calendarDayBackgroundSelected: _darkThemePrimitives.primitives.primary,
    calendarDayForegroundSelected: BLACK,
    calendarDayBackgroundSelectedHighlighted: _darkThemePrimitives.primitives.primary100,
    calendarDayForegroundSelectedHighlighted: BLACK,
    // FileUploader
    fileUploaderBackgroundColor: _darkThemePrimitives.primitives.mono700,
    fileUploaderBackgroundColorActive: _darkThemePrimitives.primitives.mono600,
    fileUploaderBorderColorActive: _darkThemePrimitives.primitives.primary,
    fileUploaderBorderColorDefault: _darkThemePrimitives.primitives.mono500,
    fileUploaderMessageColor: _darkThemePrimitives.primitives.mono100,
    // Links
    linkText: _darkThemePrimitives.primitives.primary,
    linkVisited: _darkThemePrimitives.primitives.primary100,
    linkHover: _darkThemePrimitives.primitives.primary200,
    linkActive: _darkThemePrimitives.primitives.primary300,
    // List
    listHeaderFill: _darkThemePrimitives.primitives.mono600,
    listBodyFill: _darkThemePrimitives.primitives.mono700,
    listIconFill: _darkThemePrimitives.primitives.mono100,
    listBorder: _darkThemePrimitives.primitives.mono500,
    // ProgressSteps
    progressStepsCompletedText: BLACK,
    progressStepsCompletedFill: _darkThemePrimitives.primitives.primary,
    progressStepsActiveText: BLACK,
    progressStepsActiveFill: _darkThemePrimitives.primitives.primary,
    // Modal
    modalCloseColor: _darkThemePrimitives.primitives.mono300,
    modalCloseColorHover: _darkThemePrimitives.primitives.mono400,
    modalCloseColorFocus: _darkThemePrimitives.primitives.mono400,
    // Notification
    notificationPrimaryBackground: _darkThemePrimitives.primitives.primary700,
    notificationPrimaryText: _darkThemePrimitives.primitives.primary200,
    notificationInfoBackground: _darkThemePrimitives.primitives.accent700,
    notificationInfoText: _darkThemePrimitives.primitives.accent200,
    notificationPositiveBackground: _darkThemePrimitives.primitives.positive700,
    notificationPositiveText: _darkThemePrimitives.primitives.positive200,
    notificationWarningBackground: _darkThemePrimitives.primitives.warning700,
    notificationWarningText: _darkThemePrimitives.primitives.warning200,
    notificationNegativeBackground: _darkThemePrimitives.primitives.negative700,
    notificationNegativeText: _darkThemePrimitives.primitives.negative200,
    // Tag
    tagSolidRampUnit: '500',
    tagSolidHoverRampUnit: '500',
    tagSolidActiveRampUnit: '400',
    tagSolidDisabledRampUnit: '700',
    tagSolidFontRampUnit: '100',
    tagSolidFontHoverRampUnit: '100',
    tagLightRampUnit: '700',
    tagLightHoverRampUnit: '700',
    tagLightActiveRampUnit: '600',
    tagLightDisabledRampUnit: '700',
    tagLightFontRampUnit: '100',
    tagLightFontHoverRampUnit: '100',
    tagOutlinedRampUnit: '500',
    tagOutlinedHoverRampUnit: '400',
    tagOutlinedActiveRampUnit: '300',
    tagOutlinedDisabledRampUnit: '700',
    tagOutlinedFontRampUnit: '200',
    tagOutlinedFontHoverRampUnit: '700',
    tagFontDisabledRampUnit: '500',
    tagNeutralSolidBackground: _darkThemePrimitives.primitives.mono600,
    tagNeutralSolidHover: _darkThemePrimitives.primitives.mono600,
    tagNeutralSolidActive: _darkThemePrimitives.primitives.mono500,
    tagNeutralSolidDisabled: _darkThemePrimitives.primitives.mono700,
    tagNeutralSolidFont: _darkThemePrimitives.primitives.mono200,
    tagNeutralSolidFontHover: _darkThemePrimitives.primitives.mono200,
    tagNeutralLightBackground: _darkThemePrimitives.primitives.mono800,
    tagNeutralLightHover: _darkThemePrimitives.primitives.mono800,
    tagNeutralLightActive: _darkThemePrimitives.primitives.mono700,
    tagNeutralLightDisabled: _darkThemePrimitives.primitives.mono700,
    tagNeutralLightFont: _darkThemePrimitives.primitives.mono200,
    tagNeutralLightFontHover: _darkThemePrimitives.primitives.mono200,
    tagNeutralOutlinedBackground: _darkThemePrimitives.primitives.mono600,
    tagNeutralOutlinedHover: _darkThemePrimitives.primitives.mono500,
    tagNeutralOutlinedActive: _darkThemePrimitives.primitives.mono400,
    tagNeutralOutlinedDisabled: _darkThemePrimitives.primitives.mono700,
    tagNeutralOutlinedFont: _darkThemePrimitives.primitives.mono200,
    tagNeutralOutlinedFontHover: _darkThemePrimitives.primitives.mono900,
    tagNeutralFontDisabled: _darkThemePrimitives.primitives.mono500,
    tagPrimarySolidBackground: _darkThemePrimitives.primitives.primary,
    tagPrimarySolidHover: _darkThemePrimitives.primitives.primary700,
    tagPrimarySolidActive: _darkThemePrimitives.primitives.primary400,
    tagPrimarySolidDisabled: _darkThemePrimitives.primitives.primary700,
    tagPrimarySolidFont: _darkThemePrimitives.primitives.primary700,
    tagPrimarySolidFontHover: _darkThemePrimitives.primitives.primary100,
    tagPrimaryLightBackground: _darkThemePrimitives.primitives.primary700,
    tagPrimaryLightHover: _darkThemePrimitives.primitives.primary700,
    tagPrimaryLightActive: _darkThemePrimitives.primitives.primary600,
    tagPrimaryLightDisabled: _darkThemePrimitives.primitives.primary700,
    tagPrimaryLightFont: _darkThemePrimitives.primitives.primary100,
    tagPrimaryLightFontHover: _darkThemePrimitives.primitives.primary100,
    tagPrimaryOutlinedBackground: _darkThemePrimitives.primitives.primary,
    tagPrimaryOutlinedHover: _darkThemePrimitives.primitives.primary700,
    tagPrimaryOutlinedActive: _darkThemePrimitives.primitives.primary600,
    tagPrimaryOutlinedDisabled: _darkThemePrimitives.primitives.primary700,
    tagPrimaryOutlinedFont: _darkThemePrimitives.primitives.primary,
    tagPrimaryOutlinedFontHover: _darkThemePrimitives.primitives.primary50,
    tagPrimaryFontDisabled: _darkThemePrimitives.primitives.primary500,
    tagAccentSolidBackground: _darkThemePrimitives.primitives.accent500,
    tagAccentSolidHover: _darkThemePrimitives.primitives.accent500,
    tagAccentSolidActive: _darkThemePrimitives.primitives.accent400,
    tagAccentSolidDisabled: _darkThemePrimitives.primitives.accent700,
    tagAccentSolidFont: _darkThemePrimitives.primitives.accent100,
    tagAccentSolidFontHover: _darkThemePrimitives.primitives.accent100,
    tagAccentLightBackground: _darkThemePrimitives.primitives.accent700,
    tagAccentLightHover: _darkThemePrimitives.primitives.accent700,
    tagAccentLightActive: _darkThemePrimitives.primitives.accent600,
    tagAccentLightDisabled: _darkThemePrimitives.primitives.accent700,
    tagAccentLightFont: _darkThemePrimitives.primitives.accent100,
    tagAccentLightFontHover: _darkThemePrimitives.primitives.accent100,
    tagAccentOutlinedBackground: _darkThemePrimitives.primitives.accent500,
    tagAccentOutlinedHover: _darkThemePrimitives.primitives.accent400,
    tagAccentOutlinedActive: _darkThemePrimitives.primitives.accent300,
    tagAccentOutlinedDisabled: _darkThemePrimitives.primitives.accent700,
    tagAccentOutlinedFont: _darkThemePrimitives.primitives.accent200,
    tagAccentOutlinedFontHover: _darkThemePrimitives.primitives.accent700,
    tagAccentFontDisabled: _darkThemePrimitives.primitives.accent500,
    tagPositiveSolidBackground: _darkThemePrimitives.primitives.positive500,
    tagPositiveSolidHover: _darkThemePrimitives.primitives.positive500,
    tagPositiveSolidActive: _darkThemePrimitives.primitives.positive400,
    tagPositiveSolidDisabled: _darkThemePrimitives.primitives.positive700,
    tagPositiveSolidFont: _darkThemePrimitives.primitives.positive100,
    tagPositiveSolidFontHover: _darkThemePrimitives.primitives.positive100,
    tagPositiveLightBackground: _darkThemePrimitives.primitives.positive700,
    tagPositiveLightHover: _darkThemePrimitives.primitives.positive700,
    tagPositiveLightActive: _darkThemePrimitives.primitives.positive600,
    tagPositiveLightDisabled: _darkThemePrimitives.primitives.positive700,
    tagPositiveLightFont: _darkThemePrimitives.primitives.positive100,
    tagPositiveLightFontHover: _darkThemePrimitives.primitives.positive100,
    tagPositiveOutlinedBackground: _darkThemePrimitives.primitives.positive500,
    tagPositiveOutlinedHover: _darkThemePrimitives.primitives.positive400,
    tagPositiveOutlinedActive: _darkThemePrimitives.primitives.positive300,
    tagPositiveOutlinedDisabled: _darkThemePrimitives.primitives.positive700,
    tagPositiveOutlinedFont: _darkThemePrimitives.primitives.positive200,
    tagPositiveOutlinedFontHover: _darkThemePrimitives.primitives.positive700,
    tagPositiveFontDisabled: _darkThemePrimitives.primitives.positive500,
    tagWarningSolidBackground: _darkThemePrimitives.primitives.warning500,
    tagWarningSolidHover: _darkThemePrimitives.primitives.warning500,
    tagWarningSolidActive: _darkThemePrimitives.primitives.warning400,
    tagWarningSolidDisabled: _darkThemePrimitives.primitives.warning700,
    tagWarningSolidFont: _darkThemePrimitives.primitives.warning100,
    tagWarningSolidFontHover: _darkThemePrimitives.primitives.warning100,
    tagWarningLightBackground: _darkThemePrimitives.primitives.warning700,
    tagWarningLightHover: _darkThemePrimitives.primitives.warning700,
    tagWarningLightActive: _darkThemePrimitives.primitives.warning600,
    tagWarningLightDisabled: _darkThemePrimitives.primitives.warning700,
    tagWarningLightFont: _darkThemePrimitives.primitives.warning100,
    tagWarningLightFontHover: _darkThemePrimitives.primitives.warning100,
    tagWarningOutlinedBackground: _darkThemePrimitives.primitives.warning500,
    tagWarningOutlinedHover: _darkThemePrimitives.primitives.warning400,
    tagWarningOutlinedActive: _darkThemePrimitives.primitives.warning300,
    tagWarningOutlinedDisabled: _darkThemePrimitives.primitives.warning700,
    tagWarningOutlinedFont: _darkThemePrimitives.primitives.warning200,
    tagWarningOutlinedFontHover: _darkThemePrimitives.primitives.warning700,
    tagWarningFontDisabled: _darkThemePrimitives.primitives.warning500,
    tagNegativeSolidBackground: _darkThemePrimitives.primitives.negative500,
    tagNegativeSolidHover: _darkThemePrimitives.primitives.negative500,
    tagNegativeSolidActive: _darkThemePrimitives.primitives.negative400,
    tagNegativeSolidDisabled: _darkThemePrimitives.primitives.negative700,
    tagNegativeSolidFont: _darkThemePrimitives.primitives.negative100,
    tagNegativeSolidFontHover: _darkThemePrimitives.primitives.negative100,
    tagNegativeLightBackground: _darkThemePrimitives.primitives.negative700,
    tagNegativeLightHover: _darkThemePrimitives.primitives.negative700,
    tagNegativeLightActive: _darkThemePrimitives.primitives.negative600,
    tagNegativeLightDisabled: _darkThemePrimitives.primitives.negative700,
    tagNegativeLightFont: _darkThemePrimitives.primitives.negative100,
    tagNegativeLightFontHover: _darkThemePrimitives.primitives.negative100,
    tagNegativeOutlinedBackground: _darkThemePrimitives.primitives.negative500,
    tagNegativeOutlinedHover: _darkThemePrimitives.primitives.negative400,
    tagNegativeOutlinedActive: _darkThemePrimitives.primitives.negative300,
    tagNegativeOutlinedDisabled: _darkThemePrimitives.primitives.negative700,
    tagNegativeOutlinedFont: _darkThemePrimitives.primitives.negative200,
    tagNegativeOutlinedFontHover: _darkThemePrimitives.primitives.negative700,
    tagNegativeFontDisabled: _darkThemePrimitives.primitives.negative500,
    // Table
    tableHeadBackgroundColor: _darkThemePrimitives.primitives.mono700,
    tableBackground: _darkThemePrimitives.primitives.mono800,
    tableStripedBackground: _darkThemePrimitives.primitives.mono700,
    tableFilter: _darkThemePrimitives.primitives.mono400,
    tableFilterHeading: _darkThemePrimitives.primitives.mono300,
    tableFilterBackground: _darkThemePrimitives.primitives.mono700,
    tableFilterFooterBackground: _darkThemePrimitives.primitives.mono800,
    // Tick
    tickFill: _darkThemePrimitives.primitives.mono1000,
    tickFillHover: _darkThemePrimitives.primitives.mono700,
    tickFillActive: _darkThemePrimitives.primitives.mono600,
    tickFillSelected: _darkThemePrimitives.primitives.primary,
    tickFillSelectedHover: _darkThemePrimitives.primitives.primary50,
    tickFillSelectedHoverActive: _darkThemePrimitives.primitives.primary100,
    tickFillError: _darkThemePrimitives.primitives.negative700,
    tickFillErrorHover: _darkThemePrimitives.primitives.negative600,
    tickFillErrorHoverActive: _darkThemePrimitives.primitives.negative500,
    tickFillErrorSelected: _darkThemePrimitives.primitives.negative500,
    tickFillErrorSelectedHover: _darkThemePrimitives.primitives.negative600,
    tickFillErrorSelectedHoverActive: _darkThemePrimitives.primitives.negative700,
    tickFillDisabled: _darkThemePrimitives.primitives.mono700,
    tickBorder: _darkThemePrimitives.primitives.mono300,
    tickBorderError: _darkThemePrimitives.primitives.negative400,
    tickMarkFill: BLACK,
    tickMarkFillError: WHITE,
    tickMarkFillDisabled: _darkThemePrimitives.primitives.mono400,
    // Slider/Toggle
    sliderTrackFill: _darkThemePrimitives.primitives.mono600,
    sliderTrackFillHover: _darkThemePrimitives.primitives.mono500,
    sliderTrackFillActive: _darkThemePrimitives.primitives.mono400,
    sliderTrackFillSelected: _darkThemePrimitives.primitives.primary500,
    sliderTrackFillSelectedActive: _darkThemePrimitives.primitives.primary600,
    sliderTrackFillSelectedHover: _darkThemePrimitives.primitives.primary700,
    sliderTrackFillDisabled: _darkThemePrimitives.primitives.mono700,
    sliderHandleFill: _darkThemePrimitives.primitives.mono300,
    sliderHandleFillHover: _darkThemePrimitives.primitives.mono300,
    sliderHandleFillActive: _darkThemePrimitives.primitives.mono300,
    sliderHandleFillSelected: _darkThemePrimitives.primitives.primary500,
    sliderHandleFillSelectedHover: _darkThemePrimitives.primitives.primary600,
    sliderHandleFillSelectedActive: _darkThemePrimitives.primitives.primary700,
    sliderHandleFillDisabled: _darkThemePrimitives.primitives.mono600,
    sliderHandleInnerFill: _darkThemePrimitives.primitives.mono300,
    sliderHandleInnerFillDisabled: _darkThemePrimitives.primitives.mono500,
    sliderHandleInnerFillSelectedHover: _darkThemePrimitives.primitives.primary600,
    sliderHandleInnerFillSelectedActive: _darkThemePrimitives.primitives.primary700,
    sliderBorder: WHITE,
    sliderBorderHover: WHITE,
    sliderBorderDisabled: _darkThemePrimitives.primitives.mono400,
    // Input
    inputFill: _darkThemePrimitives.primitives.mono600,
    inputFillActive: _darkThemePrimitives.primitives.mono500,
    inputFillError: _darkThemePrimitives.primitives.negative700,
    inputFillDisabled: _darkThemePrimitives.primitives.mono800,
    inputFillPositive: _darkThemePrimitives.primitives.positive700,
    inputTextDisabled: _darkThemePrimitives.primitives.mono500,
    inputBorderError: _darkThemePrimitives.primitives.negative400,
    inputBorderPositive: _darkThemePrimitives.primitives.positive400,
    inputEnhancerFill: _darkThemePrimitives.primitives.mono500,
    inputEnhancerFillDisabled: _darkThemePrimitives.primitives.mono700,
    inputEnhancerTextDisabled: _darkThemePrimitives.primitives.mono500,
    // Menu
    menuFill: _darkThemePrimitives.primitives.mono600,
    menuFillHover: _darkThemePrimitives.primitives.mono700,
    menuFontDefault: _darkThemePrimitives.primitives.mono300,
    menuFontDisabled: _darkThemePrimitives.primitives.mono400,
    menuFontHighlighted: _darkThemePrimitives.primitives.mono200,
    menuFontSelected: WHITE,
    // Pagination
    paginationTriangleDown: _darkThemePrimitives.primitives.mono100,
    // Header navigation
    headerNavigationFill: _darkThemePrimitives.primitives.mono700,
    // Tab
    tabBarFill: _darkThemePrimitives.primitives.mono1000,
    tabColor: _darkThemePrimitives.primitives.mono300,
    // Spinner
    spinnerTrackFill: _darkThemePrimitives.primitives.mono100,
    // Progress bar
    progressbarTrackFill: _darkThemePrimitives.primitives.mono100,
    // Tooltip
    tooltipBackground: _darkThemePrimitives.primitives.mono200,
    tooltipText: _darkThemePrimitives.primitives.mono1000
  }
};
exports.default = _default;